%global commit 4653c12fbfd94b1423111d9f296a764a43b59b6c
%global shortcommit %(c=%{commit}; echo ${c:0:7})

Name:           smooks
Version:        1.5.1
Release:        8%{?dist}
Summary:        Smooks Framework

Group:          Development/Libraries
License:        LGPLv2+ and ASL 2.0
URL:            http://www.%{name}.org/
Source0:        https://github.com/%{name}/%{name}/archive/%{commit}/%{name}-%{version}-%{shortcommit}.tar.gz
Source1:        http://www.apache.org/licenses/LICENSE-2.0.txt

Patch0:         %{name}-non-utf8-char.patch

# Compensate for newer hsqldb
Patch1:         %{name}-f20-hsqldb.patch
BuildArch:      noarch

BuildRequires: maven-local
BuildRequires: mvn(jaxen:jaxen)
BuildRequires: mvn(org.mvel:mvel2)
BuildRequires: mvn(xerces:xercesImpl)
BuildRequires: mvn(org.yaml:snakeyaml)
BuildRequires: mvn(javassist:javassist)
BuildRequires: mvn(com.wutka:dtdparser)
BuildRequires: mvn(javax.transaction:jta)
BuildRequires: mvn(net.sf.opencsv:opencsv)
BuildRequires: mvn(javax.xml.bind:jaxb-api)
BuildRequires: mvn(commons-lang:commons-lang)
BuildRequires: mvn(org.freemarker:freemarker)
BuildRequires: mvn(org.codehaus:codehaus-parent)
BuildRequires: mvn(commons-logging:commons-logging)
BuildRequires: mvn(com.thoughtworks.xstream:xstream)
BuildRequires: mvn(org.codehaus.jackson:jackson-core-asl)
BuildRequires: mvn(org.apache.maven.plugins:maven-source-plugin)
BuildRequires: mvn(org.apache.maven.plugins:maven-assembly-plugin)
BuildRequires: mvn(org.apache.maven.plugins:maven-compiler-plugin)
BuildRequires: mvn(org.apache.maven.plugins:maven-surefire-plugin)

%if 0%{?fedora} >= 20
BuildRequires: mvn(org.hsqldb:hsqldb)
%else
BuildRequires: mvn(hsqldb:hsqldb:1)
%endif

%description
Smooks is an extensible framework for building applications for
processing XML and non XML data (CSV, EDI, Java etc) using Java.

%package javadoc
Summary: Javadoc for %{name}

%description javadoc
API documentation for %{name}.

%package -n milyn
Summary: Milyn (Base POM)

%description -n milyn
%{summary}.

%package -n milyn-commons
Summary: Milyn Commons

%description -n milyn-commons
Common classes for Milyn modules.

%package -n milyn-%{name}-core
Summary: Content Filtering and Serialisation Framework

%description -n milyn-%{name}-core
Smooks is a framework for "fragment based" filtering and
serialisation of XML (.. XHTML/HTML etc).  It allows you perform
transformation and analysis on messages using different technologies
(Java, Groovy, XSLT, StringTemplate, etc) both separately and in
collaboration i.e. it allows you mix technologies within the scope
of a single message transformation.
Smooks can also be used simply as an XML analysis tool.

%package -n %{name}-cartridge-base-pom
Summary: Base POM for Milyn Smooks Cartridges

%description -n %{name}-cartridge-base-pom
%{summary}.

%package -n milyn-%{name}-javabean
Summary: Milyn Smooks Cartridge - Javabean

%description -n milyn-%{name}-javabean
%{summary}.

%package -n milyn-%{name}-flatfile
Summary: Milyn Smooks Cartridge - Flat File

%description -n milyn-%{name}-flatfile
%{summary}.

%package -n milyn-%{name}-csv
Summary: Milyn Smooks Cartridge - CSV

%description -n milyn-%{name}-csv
%{summary}.

%package -n milyn-%{name}-edi
Summary: Milyn Smooks Cartridge - EDI

%description -n milyn-%{name}-edi
%{summary}.

%package -n milyn-%{name}-json
Summary: Milyn Smooks Cartridge - JSON

%description -n milyn-%{name}-json
%{summary}.

%package -n milyn-%{name}-misc
Summary: Milyn Smooks Cartridge - Misc

%description -n milyn-%{name}-misc
%{summary}.

%package -n milyn-%{name}-calc
Summary: Milyn Smooks Cartridge - Calculation

%description -n milyn-%{name}-calc
%{summary}.

%package -n milyn-%{name}-rules
Summary: Milyn Smooks Cartridge - Rules

%description -n milyn-%{name}-rules
%{summary}.

%package -n milyn-%{name}-validation
Summary: Milyn Smooks Cartridge - Validation

%description -n milyn-%{name}-validation
%{summary}.

%package -n milyn-%{name}-fixed-length
Summary: Milyn Smooks Cartridge - Fixed Length Reader

%description -n milyn-%{name}-fixed-length
%{summary}.

%package -n milyn-%{name}-yaml
Summary: Milyn Smooks Cartridge - YAML

%description -n milyn-%{name}-yaml
%{summary}.

%package -n milyn-edisax-parser
Summary: Milyn Edisax Parser

%description -n milyn-edisax-parser
%{summary}.

%prep
%setup -qn %{name}-%{commit}
cp %{SOURCE1} .

find -name '*.jar' -delete
find -name '*.class' -delete

%pom_disable_module edi
%pom_disable_module scribe
%pom_disable_module testres
%pom_disable_module %{name}-examples

# Needs mvn(org.ow2.bundles:ow2-bundles-externals-opencsv)
%pom_disable_module %{name}-all

# Needs mvn(org.eclipse.xsd:org.eclipse.xsd)
%pom_disable_module edi/ect
%pom_disable_module edi/ect/maven-ect-plugin
%pom_disable_module edi/ejc
%pom_disable_module edi/ejc/maven-ejc-plugin
%pom_disable_module edi/edi-test

# Needs mvn(org.codehaus.groovy:groovy-all)
%pom_disable_module scripting %{name}-cartridges
%pom_disable_module persistence %{name}-cartridges

# Needs mvn(antlr:stringtemplate)
%pom_disable_module templating %{name}-cartridges
%pom_disable_module routing %{name}-cartridges
%pom_disable_module camel %{name}-cartridges

%pom_remove_dep dtdparser:dtdparser smooks-core
%pom_add_dep com.wutka:dtdparser smooks-core

%pom_remove_dep hsqldb:hsqldb commons
%if 0%{?fedora} >= 20
%pom_add_dep org.hsqldb:hsqldb commons
%else
%pom_add_dep hsqldb:hsqldb commons
%endif

%pom_add_dep xerces:xercesImpl smooks-cartridges/yaml

%pom_remove_dep org.milyn:testres smooks-cartridges

%pom_remove_dep org.codehaus.jackson:jackson-core-lgpl smooks-cartridges/json
%pom_add_dep org.codehaus.jackson:jackson-core-asl smooks-cartridges/json

# Remove bundled library
rm -rf commons/src/main/java/org/milyn/annotation/

%patch0

%if 0%{?fedora} >= 20
%patch1
%endif

%build
# We don't have mockobjects, so can't run tests
%mvn_build -s --skip-tests

%install
%mvn_install

#files -f .mfiles
%files javadoc -f .mfiles-javadoc
%doc LICENSE-2.0.txt
%files -n milyn -f .mfiles-milyn
%doc LICENSE-2.0.txt
%files -n milyn-commons -f .mfiles-milyn-commons
%doc LICENSE-2.0.txt
%files -n milyn-smooks-core -f .mfiles-milyn-smooks-core
%files -n smooks-cartridge-base-pom -f .mfiles-smooks-cartridge-base-pom
%files -n milyn-%{name}-javabean -f .mfiles-milyn-%{name}-javabean
%files -n milyn-%{name}-flatfile -f .mfiles-milyn-%{name}-flatfile
%files -n milyn-%{name}-csv -f .mfiles-milyn-%{name}-csv
%files -n milyn-%{name}-edi -f .mfiles-milyn-%{name}-edi
%files -n milyn-%{name}-json -f .mfiles-milyn-%{name}-json
%files -n milyn-%{name}-misc -f .mfiles-milyn-%{name}-misc
%files -n milyn-%{name}-calc -f .mfiles-milyn-%{name}-calc
%files -n milyn-%{name}-rules -f .mfiles-milyn-%{name}-rules
%files -n milyn-%{name}-validation -f .mfiles-milyn-%{name}-validation
%files -n milyn-%{name}-fixed-length -f .mfiles-milyn-%{name}-fixed-length
%files -n milyn-%{name}-yaml -f .mfiles-milyn-%{name}-yaml
%files -n milyn-edisax-parser -f .mfiles-milyn-edisax-parser

%changelog
* Sun Jun 08 2014 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 1.5.1-8
- Rebuilt for https://fedoraproject.org/wiki/Fedora_21_Mass_Rebuild

* Fri Feb 28 2014 Gerard Ryan <galileo@fedoraproject.org> - 1.5.1-7
- RHBZ-1068537: Switch to java-headless requires

* Sun Aug 4 2013 Gerard Ryan <galileo@fedoraproject.org> - 1.5.1-6
- Fix hsqldb resolution problem

* Wed Jul 31 2013 Gerard Ryan <galileo@fedoraproject.org> - 1.5.1-5
- Add missing changelog entry

* Wed Jul 31 2013 Gerard Ryan <galileo@fedoraproject.org> - 1.5.1-4
- Clean up BuildRequires

* Wed Jul 31 2013 Gerard Ryan <galileo@fedoraproject.org> - 1.5.1-3
- Remove bundled library and dependent subpackages
- Add ASL 2.0 license and text

* Tue Jul 30 2013 Gerard Ryan <galileo@fedoraproject.org> - 1.5.1-2
- RHBZ-989266: Fix hsqldb version; add BR's
- Remove milyn-smooks-camel subpackage

* Sat Jul 27 2013 Gerard Ryan <galileo@fedoraproject.org> - 1.5.1-1
- Initial package.
